'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseIcons = exports.createBaseImageAsync = undefined;

var _toConsumableArray2;

function _load_toConsumableArray() {
  return _toConsumableArray2 = _interopRequireDefault(require('babel-runtime/helpers/toConsumableArray'));
}

var _objectWithoutProperties2;

function _load_objectWithoutProperties() {
  return _objectWithoutProperties2 = _interopRequireDefault(require('babel-runtime/helpers/objectWithoutProperties'));
}

var _getIterator2;

function _load_getIterator() {
  return _getIterator2 = _interopRequireDefault(require('babel-runtime/core-js/get-iterator'));
}

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _promise;

function _load_promise() {
  return _promise = _interopRequireDefault(require('babel-runtime/core-js/promise'));
}

var _asyncToGenerator2;

function _load_asyncToGenerator() {
  return _asyncToGenerator2 = _interopRequireDefault(require('babel-runtime/helpers/asyncToGenerator'));
}

var createBaseImageAsync = exports.createBaseImageAsync = function () {
  var _ref = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(width, height, color) {
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt('return', new (_promise || _load_promise()).default(function (resolve, reject) {
              return new (_jimp || _load_jimp()).default(width, height, color, function (err, image) {
                if (err) {
                  reject(err);
                  return;
                }
                resolve(image);
              });
            }));

          case 1:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function createBaseImageAsync(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var compositeImagesAsync = function () {
  var _ref2 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(image) {
    for (var _len = arguments.length, images = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      images[_key - 1] = arguments[_key];
    }

    var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, imageProps, childImage;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context2.prev = 3;
            _iterator = (0, (_getIterator2 || _load_getIterator()).default)(images);

          case 5:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context2.next = 14;
              break;
            }

            imageProps = _step.value;
            _context2.next = 9;
            return (_jimp || _load_jimp()).default.read(imageProps);

          case 9:
            childImage = _context2.sent;

            image.composite(childImage, 0, 0);

          case 11:
            _iteratorNormalCompletion = true;
            _context2.next = 5;
            break;

          case 14:
            _context2.next = 20;
            break;

          case 16:
            _context2.prev = 16;
            _context2.t0 = _context2['catch'](3);
            _didIteratorError = true;
            _iteratorError = _context2.t0;

          case 20:
            _context2.prev = 20;
            _context2.prev = 21;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 23:
            _context2.prev = 23;

            if (!_didIteratorError) {
              _context2.next = 26;
              break;
            }

            throw _iteratorError;

          case 26:
            return _context2.finish(23);

          case 27:
            return _context2.finish(20);

          case 28:
            return _context2.abrupt('return', image);

          case 29:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this, [[3, 16, 20, 28], [21,, 23, 27]]);
  }));

  return function compositeImagesAsync(_x4) {
    return _ref2.apply(this, arguments);
  };
}();

var getBufferWithMimeAsync = function () {
  var _ref3 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(_ref4, mimeType, _ref5) {
    var src = _ref4.src,
        resizeMode = _ref4.resizeMode,
        color = _ref4.color;
    var width = _ref5.width,
        height = _ref5.height;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (supportedMimeTypes.includes(mimeType)) {
              _context3.next = 10;
              break;
            }

            _context3.prev = 1;
            return _context3.abrupt('return', (_fsExtra || _load_fsExtra()).default.readFileSync(src));

          case 5:
            _context3.prev = 5;
            _context3.t0 = _context3['catch'](1);
            throw new (_IconError || _load_IconError()).default('It was not possible to read \'' + src + '\'.');

          case 8:
            _context3.next = 13;
            break;

          case 10:
            _context3.next = 12;
            return resize(src, mimeType, width, height, resizeMode, color);

          case 12:
            return _context3.abrupt('return', _context3.sent);

          case 13:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this, [[1, 5]]);
  }));

  return function getBufferWithMimeAsync(_x5, _x6, _x7) {
    return _ref3.apply(this, arguments);
  };
}();

var processImage = function () {
  var _ref6 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(size, icon, fingerprint, publicPath) {
    var _parseSize, width, height, mimeType, _buffer;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _parseSize = parseSize(size), width = _parseSize.width, height = _parseSize.height;

            if (!(width <= 0 || height <= 0)) {
              _context4.next = 3;
              break;
            }

            return _context4.abrupt('return');

          case 3:
            mimeType = (_mime || _load_mime()).default.getType(icon.src);
            _context4.next = 6;
            return getBufferWithMimeAsync(icon, mimeType, { width: width, height: height });

          case 6:
            _buffer = _context4.sent;
            return _context4.abrupt('return', processIcon(width, height, icon, _buffer, mimeType, publicPath, fingerprint));

          case 8:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function processImage(_x8, _x9, _x10, _x11) {
    return _ref6.apply(this, arguments);
  };
}();

var resize = function () {
  var _ref7 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(img, mimeType, width, height) {
    var resizeMode = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 'contain';
    var color = arguments[5];
    var initialImage, center, resizedImage, splashScreen, combinedImage, message;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.prev = 0;
            _context5.next = 3;
            return (_jimp || _load_jimp()).default.read(img);

          case 3:
            initialImage = _context5.sent;
            center = (_jimp || _load_jimp()).default.VERTICAL_ALIGN_MIDDLE | (_jimp || _load_jimp()).default.HORIZONTAL_ALIGN_CENTER;

            if (!(resizeMode === ASPECT_FILL)) {
              _context5.next = 11;
              break;
            }

            _context5.next = 8;
            return initialImage.cover(width, height, center).quality(100).getBufferAsync(mimeType);

          case 8:
            return _context5.abrupt('return', _context5.sent);

          case 11:
            if (!(resizeMode === ASPECT_FIT)) {
              _context5.next = 26;
              break;
            }

            _context5.next = 14;
            return initialImage.contain(width, height, center).quality(100);

          case 14:
            resizedImage = _context5.sent;

            if (color) {
              _context5.next = 17;
              break;
            }

            return _context5.abrupt('return', resizedImage.getBufferAsync(mimeType));

          case 17:
            _context5.next = 19;
            return createBaseImageAsync(width, height, color);

          case 19:
            splashScreen = _context5.sent;
            _context5.next = 22;
            return compositeImagesAsync(splashScreen, resizedImage);

          case 22:
            combinedImage = _context5.sent;
            return _context5.abrupt('return', combinedImage.getBufferAsync(mimeType));

          case 26:
            throw new (_IconError || _load_IconError()).default('Unsupported resize mode: ' + resizeMode + '. Please choose either \'cover\', or \'contain\'');

          case 27:
            _context5.next = 33;
            break;

          case 29:
            _context5.prev = 29;
            _context5.t0 = _context5['catch'](0);
            message = _context5.t0.message;
            throw new (_IconError || _load_IconError()).default('It was not possible to generate splash screen \'' + img + '\'. ' + message);

          case 33:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this, [[0, 29]]);
  }));

  return function resize(_x12, _x13, _x14, _x15) {
    return _ref7.apply(this, arguments);
  };
}();

var parseIcons = exports.parseIcons = function () {
  var _ref9 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7(inputIcons, fingerprint, publicPath) {
    var _this = this;

    var icons, assets, promises, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _loop, _iterator2, _step2;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            if (inputIcons.length) {
              _context7.next = 2;
              break;
            }

            return _context7.abrupt('return', {});

          case 2:
            icons = [];
            assets = [];
            promises = [];
            _iteratorNormalCompletion2 = true;
            _didIteratorError2 = false;
            _iteratorError2 = undefined;
            _context7.prev = 8;

            _loop = function _loop() {
              var icon = _step2.value;
              var sizes = icon.sizes;

              promises = [].concat((0, (_toConsumableArray2 || _load_toConsumableArray()).default)(promises), (0, (_toConsumableArray2 || _load_toConsumableArray()).default)(sizes.map(function () {
                var _ref12 = (0, (_asyncToGenerator2 || _load_asyncToGenerator()).default)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(size) {
                  var _ref13, manifestIcon, webpackAsset;

                  return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
                    while (1) {
                      switch (_context6.prev = _context6.next) {
                        case 0:
                          _context6.next = 2;
                          return processImage(size, icon, fingerprint, publicPath);

                        case 2:
                          _ref13 = _context6.sent;
                          manifestIcon = _ref13.manifestIcon;
                          webpackAsset = _ref13.webpackAsset;

                          icons.push(manifestIcon);
                          assets.push(webpackAsset);

                        case 7:
                        case 'end':
                          return _context6.stop();
                      }
                    }
                  }, _callee6, _this);
                }));

                return function (_x20) {
                  return _ref12.apply(this, arguments);
                };
              }())));
            };

            for (_iterator2 = (0, (_getIterator2 || _load_getIterator()).default)(inputIcons); !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              _loop();
            }
            _context7.next = 17;
            break;

          case 13:
            _context7.prev = 13;
            _context7.t0 = _context7['catch'](8);
            _didIteratorError2 = true;
            _iteratorError2 = _context7.t0;

          case 17:
            _context7.prev = 17;
            _context7.prev = 18;

            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }

          case 20:
            _context7.prev = 20;

            if (!_didIteratorError2) {
              _context7.next = 23;
              break;
            }

            throw _iteratorError2;

          case 23:
            return _context7.finish(20);

          case 24:
            return _context7.finish(17);

          case 25:
            _context7.next = 27;
            return (_promise || _load_promise()).default.all(promises);

          case 27:
            return _context7.abrupt('return', {
              icons: icons.filter(function (icon) {
                return icon;
              }).sort(function (_ref10, _ref11) {
                var sizes = _ref10.sizes;
                var sizesB = _ref11.sizes;

                if (sizes < sizesB) return -1;else if (sizes > sizesB) return 1;
                return 0;
              }),
              // startupImages: icons.filter(({ isStartupImage }) => isStartupImage),
              assets: assets
            });

          case 28:
          case 'end':
            return _context7.stop();
        }
      }
    }, _callee7, this, [[8, 13, 17, 25], [18,, 20, 24]]);
  }));

  return function parseIcons(_x17, _x18, _x19) {
    return _ref9.apply(this, arguments);
  };
}();

exports.retrieveIcons = retrieveIcons;

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _jimp;

function _load_jimp() {
  return _jimp = _interopRequireDefault(require('jimp'));
}

var _mime;

function _load_mime() {
  return _mime = _interopRequireDefault(require('mime'));
}

var _uri;

function _load_uri() {
  return _uri = require('./helpers/uri');
}

var _fingerprint;

function _load_fingerprint() {
  return _fingerprint = _interopRequireDefault(require('./helpers/fingerprint'));
}

var _IconError;

function _load_IconError() {
  return _IconError = _interopRequireDefault(require('./errors/IconError'));
}

var _Apple;

function _load_Apple() {
  return _Apple = require('./validators/Apple');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var supportedMimeTypes = [(_jimp || _load_jimp()).default.MIME_PNG, (_jimp || _load_jimp()).default.MIME_JPEG, (_jimp || _load_jimp()).default.MIME_BMP];

var ASPECT_FILL = 'cover';
var ASPECT_FIT = 'contain';

function parseArray(i) {
  if (i == null) return [];
  return i && !Array.isArray(i) ? [i] : i;
}

function sanitizeIcon(iconSnippet) {
  if (!iconSnippet.src) {
    throw new (_IconError || _load_IconError()).default('Unknown icon source.');
  }
  var sizes = parseArray(iconSnippet.size || iconSnippet.sizes);
  if (!sizes) {
    throw new (_IconError || _load_IconError()).default('Unknown icon sizes.');
  }
  return {
    src: iconSnippet.src,
    resizeMode: iconSnippet.resizeMode,
    sizes: sizes,
    media: iconSnippet.media,
    destination: iconSnippet.destination,
    ios: iconSnippet.ios || false,
    color: iconSnippet.color
  };
}

function processIcon(width, height, icon, buffer, mimeType, publicPath, shouldFingerprint) {
  var dimensions = width + 'x' + height;
  var fileName = shouldFingerprint ? 'icon_' + dimensions + '.' + (0, (_fingerprint || _load_fingerprint()).default)(buffer) + '.' + (_mime || _load_mime()).default.getExtension(mimeType) : 'icon_' + dimensions + '.' + (_mime || _load_mime()).default.getExtension(mimeType);
  var iconOutputDir = icon.destination ? (0, (_uri || _load_uri()).joinURI)(icon.destination, fileName) : fileName;
  var iconPublicUrl = (0, (_uri || _load_uri()).joinURI)(publicPath, iconOutputDir);

  var manifestIcon = null;
  if (width === height) {
    manifestIcon = {
      src: iconPublicUrl,
      sizes: dimensions,
      type: mimeType
    };
  }
  return {
    manifestIcon: manifestIcon,
    webpackAsset: {
      output: iconOutputDir,
      url: iconPublicUrl,
      source: buffer,
      size: buffer.length,
      ios: icon.ios ? { valid: icon.ios, media: icon.media, size: dimensions, href: iconPublicUrl } : false,
      resizeMode: icon.resizeMode,
      color: icon.color
    }
  };
}

function parseSize(size) {
  var width = void 0;
  var height = void 0;
  if (Array.isArray(size) && size.length) {
    // [0, 0] || [0]
    width = size[0];
    height = size.length > 1 ? size[1] : size[0];
  } else if (typeof size === 'number') {
    // 0
    width = size;
    height = size;
  } else if (typeof size === 'string') {
    // '0x0'
    var dimensions = size.split('x');
    width = dimensions[0];
    height = dimensions[1];
  }
  return { width: width, height: height };
}

function retrieveIcons(manifest) {
  // Remove these items so they aren't written to disk.
  var startupImages = manifest.startupImages,
      icons = manifest.icons,
      config = (0, (_objectWithoutProperties2 || _load_objectWithoutProperties()).default)(manifest, ['startupImages', 'icons']);

  var parsedStartupImages = parseArray(startupImages);

  var parsedIcons = parseArray(icons);

  if (parsedStartupImages.length) {
    // TODO: Bacon: use all of the startup images
    var startupImage = parsedStartupImages[0];
    parsedIcons = [].concat((0, (_toConsumableArray2 || _load_toConsumableArray()).default)(parsedIcons), (0, (_toConsumableArray2 || _load_toConsumableArray()).default)((0, (_Apple || _load_Apple()).fromStartupImage)(startupImage)));
  }

  var response = parsedIcons.map(function (icon) {
    return sanitizeIcon(icon);
  });
  return [response, config];
}
//# sourceMappingURL=__sourcemaps__/icons.js.map
